// Plugin.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "Plugin.h"
#include "DlgMain.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CString g_sAbout;

// CPluginApp

BEGIN_MESSAGE_MAP(CPluginApp, CWinApp)
END_MESSAGE_MAP()

// CPluginApp construction

CPluginApp::CPluginApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CPluginApp object

CPluginApp theApp;

// CPluginApp initialization

BOOL CPluginApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

extern "C" __declspec(dllexport) void PluginHandler(DWORD dwCode, void *pInfo, DWORD *pdwResult)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if (dwCode == PPC_INIT) //  
	{
		PLUGININFO *info = (PLUGININFO *)pInfo;

		CString sDate = CString(__DATE__);
		g_sAbout.Format("Test plugin for PasswordsPro.\nLast updated: %s, (c)InsidePro Software.", sDate);
		info->szName = "Test Plugin";
		info->szAbout = (char *)(LPCTSTR)g_sAbout;
		info->dwFlags = PPF_PASSWORD_FOUND | PPF_ATTACK_FINISHED | PPF_ATTACK_INTERRUPTED;

		*pdwResult = 1;
		return;
	}

	if (dwCode == PPC_SHOW)
	{
		CDlgMain dialog;
		dialog.DoModal();

		*pdwResult = 1;
		return;
	}

	if (dwCode == PPC_PASSWORD_FOUND)
	{
		PASSWORDINFO *info = (PASSWORDINFO *)pInfo;

		CString s;
		s.Format("Password: %s\nHash: %s\nSalt: %s\nName: %s\nComment: %s\nHash Type: %s", info->szPassword, info->szHash, info->szSalt, info->szName, info->szComment, info->szType);
		AfxMessageBox(s);

		*pdwResult = 1;
		return;
	}

	if (dwCode == PPC_ATTACK_FINISHED)
	{
		AfxMessageBox("Attack finished!");

		*pdwResult = 1;
		return;
	}

	if (dwCode == PPC_ATTACK_INTERRUPTED)
	{
		AfxMessageBox("Attack interrupted!");

		*pdwResult = 1;
		return;
	}

	*pdwResult = 0;
}
